/* Dave Pallot */
/* pallot@iinet.net.au */
/* Copyright 2000 */

#include "Thread.h"

Thread::Thread(Runnable* runnable) :
	m_running(false),
	m_run(runnable),
	m_threadHandle(0),
	m_waiting(false)
{
}

Thread::~Thread()
{
	stop();
}


bool Thread::start()
{
	if (m_threadHandle == 0)
	{
		unsigned long threadId = 0;
		
		m_threadHandle = ::CreateThread( (SECURITY_ATTRIBUTES*) 0,		   // use default security attributes
										0,								   // use default stack size
										(LPTHREAD_START_ROUTINE)ThreadProc,	// thread start routine
										(void*) m_run,								// parameter to start routine
										0,											// creation flags - run immediately
										&threadId);									// returned thread identifier

		if (m_threadHandle != 0)
		{
			m_running = true;
		}
	}

	return m_running;
}


void Thread::stop()
{
	if (m_threadHandle != 0)
	{
		if (::CloseHandle(m_threadHandle) == TRUE)
		{
			m_running = false;
			m_threadHandle = 0;
			
			if (m_waiting == true)
			{
				m_semaphore.signal();
				m_waiting = false;
			}
		}
	}
}


void Thread::join()
{
	if (m_running == true)
	{
		m_waiting = true;
		m_semaphore.wait();
	}
}


DWORD WINAPI ThreadProc(LPVOID param)
{
   Runnable* runnable = reinterpret_cast<Runnable*>(param);

   runnable->runThis();

   runnable->stop();

   return 0;
}



